import {getCars} from './getCars';
import {colorLegend} from './colorLegend';
import {sizeLegend} from './sizeLegend';

import {generateReport} from './generateReport';
import {loadAndProcessData} from './loadAndProcessData';

import {
  select,
  geoPath,
  geoMercator,
  zoom,
  event,
  format,
  max,
  sum,
  scaleOrdinal,
  scaleLinear,
  schemeCategory10,
  schemeSpectral,
  scaleSqrt,
  geoCentroid//pre umiestnenie kruznic do stredu krajin
} from 'd3';

 const projection = geoMercator() 
	.scale(8000)
	//.rotate([-0.5, 0.5, 0]) 
	.center([19.3, 48.7]); 
 const pathGenerator = geoPath().projection(projection);
 const svg=select('svg');

 const radiusValue = d => d.properties['pondelok_16.3.2020'];
 

 const populationFormat=format(',');


 
 const g=svg.append('g');
      svg.style('background-color','white');
      
  svg.call(zoom().on('zoom',()=>{
  		g.attr('transform',event.transform);
  }));
/*
  g.append('path')
   .attr('class','sphere')
   .attr('d',pathGenerator({type:'Sphere'}));
   */
const dnesnyDatum= new Date();

 
 

   loadAndProcessData().then(countries=> {  
     
   /*    colorScale
         .domain(countries.features.map(colorValue))//ordered
         .domain(colorScale.domain().sort().reverse())
          .range(schemeSpectral[colorScale.domain().length]);
    
     colorLegendG.call(colorLegend,{
           colorScale,
           circleRadius:15,
           spacing:35,
           textOffset:20,
           backgroundRectWidth:350
           });
 */
       var pripadovCelkom = sum(countries.features, function(d) { return d.properties['pondelok_16.3.2020'] });
     
     g.append('text')
        .attr('y',30)
        .attr('x',innerWidth/5)
        .attr('class','title')
          .text("Diagnostikovaných celkom : "+pripadovCelkom+" (stav k 16.3.2020)"); //*"+dnesnyDatum.toLocaleString()+")*/");
     
      const colorLegendG=svg.append('g')
        .attr('transform',`translate(50,250)`);
       // const colorScale=scaleOrdinal(schemeCategory10);
     
     
     const sizeScale=scaleLinear()
        .domain([0,max(countries.features,radiusValue)])
        .range([0,31]);
     
     
       g.selectAll('path').data(countries.features)
         .enter().append('path')
          .attr('class','country')
          .attr('fill',d=>d.properties['pondelok_16.3.2020'] ? "#feadad" : "#ffffff")
          .attr('d',pathGenerator)
            .append('title')
               // .text('Hello');
                  .text(d=>isNaN(radiusValue(d))
                      ?'missing data'
                      :[
                     d.properties['okres'],
                     populationFormat(radiusValue(d))
                          ].join(' : ')
                       );
     
   /*  const sizeScale=scaleSqrt()
	.dom
  
  ain([0,10])
  .range([0,50]);
*/
const legendGroup=g.append('g');

  
     
     
      countries.featureWithPopulation.forEach(d=>{
      d.properties.projected= projection(geoCentroid(d));
     });
      
     
        g.selectAll('circle').data(countries.featureWithPopulation)
         .enter().append('circle')
          .attr('class','country-circle')
          .attr('cy',d=>d.properties.projected[1])
          .attr('cx',d=>d.properties.projected[0])
          .attr('r',d=>sizeScale(radiusValue(d)));
     
     g.selectAll('text').data(countries.featureWithPopulation)
          .enter().append('text')
          .attr('class','titles')
          .attr('y',d=>d.properties.projected[1]+10)
          .attr('x',d=>d.properties.projected[0]+10)
          .text(d=>radiusValue(d)>0?radiusValue(d):"");
     
      legendGroup.append('g')
  .attr('transform',`translate(60,130)`)
  .call(sizeLegend,{
           sizeScale,
           spacing:35,
            numTicks:7,
           textOffset:10,
           tickFormat:populationFormat
           })
     .append('text')
      .text('Počet diagnostikovaných')
      .attr('y',-40)
      .attr('x',-30)
      .attr('class','legend-title');
 
     
  } );



 /*

  json('https://unpkg.com/world-atlas@1.1.4/world/110m.json')
     .then(data => {//it is a promise
    
	});


   */ 
		
























